diff --git a/gcc/m2/mc-boot/Gdecl.cc b/gcc/m2/mc-boot/Gdecl.cc
index defe0b29537..9af2842ca18 100644
--- a/gcc/m2/mc-boot/Gdecl.cc
+++ b/gcc/m2/mc-boot/Gdecl.cc
@@ -635,6 +635,7 @@ struct decl_moduleT_r {
 struct decl_defT_r {
                      nameKey_Name name;
                      nameKey_Name source;
+                     bool unqualified;
                      bool hasHidden;
                      bool forC;
                      Indexing_Index exported;
@@ -727,6 +728,8 @@ static decl_group freeGroup;
 static decl_group globalGroup;
 static FIO_File outputFile;
 static decl_language lang;
+static decl_node__opaque charStarN;
+static decl_node__opaque constCharStarN;
 static decl_node__opaque bitsperunitN;
 static decl_node__opaque bitsperwordN;
 static decl_node__opaque bitspercharN;
@@ -934,6 +937,18 @@ extern "C" decl_node decl_lookupModule (nameKey_Name n);
 
 extern "C" void decl_putDefForC (decl_node n);
 
+/*
+   putDefUnqualified - the definition module uses unqualified.
+*/
+
+extern "C" void decl_putDefUnqualified (decl_node n);
+
+/*
+   isDefUnqualified - returns TRUE if the definition module uses unqualified.
+*/
+
+extern "C" bool decl_isDefUnqualified (decl_node n);
+
 /*
    lookupInScope - looks up a symbol named, n, from, scope.
 */
@@ -2088,6 +2103,20 @@ static bool isLocal (decl_node__opaque n);
 
 static void importEnumFields (decl_node__opaque m, decl_node__opaque n);
 
+/*
+   checkGccType - check to see if node n is gcc tree or location_t
+                  and record its use in keyc.
+*/
+
+static void checkGccType (decl_node__opaque n);
+
+/*
+   checkCDataTypes - check to see if node n is CharStar or ConstCharStar
+                  and if necessary assign n to the global variable.
+*/
+
+static void checkCDataTypes (decl_node__opaque n);
+
 /*
    isComplex - returns TRUE if, n, is the complex type.
 */
@@ -3306,6 +3335,58 @@ static bool isDeclInImp (decl_node__opaque type);
 
 static void doTypeNameModifier (mcPretty_pretty p, decl_node__opaque n);
 
+/*
+   isGccType - return TRUE if n is tree or location_t.
+*/
+
+static bool isGccType (decl_node__opaque n);
+
+/*
+   doGccType - record whether we are going to declare tree or location_t
+               so that the appropriate gcc header can be included instead.
+*/
+
+static void doGccType (mcPretty_pretty p, decl_node__opaque n);
+
+/*
+   isCDataType - return true if n is charStar or constCharStar.
+*/
+
+static bool isCDataType (decl_node__opaque n);
+
+/*
+   isCDataTypes - return TRUE if n is CharStar or ConstCharStar.
+*/
+
+static bool isCDataTypes (decl_node__opaque n);
+
+/*
+   doCDataTypes - if we are going to declare CharStar or ConstCharStar
+               then generate a comment instead.
+*/
+
+static void doCDataTypes (mcPretty_pretty p, decl_node__opaque n);
+
+/*
+   doCDataTypesC - generate the C representation of the CDataTypes data types.
+*/
+
+static void doCDataTypesC (mcPretty_pretty p, decl_node__opaque n);
+
+/*
+   doTypeOrPointer - only declare type or pointer n providing that
+                     the name is not location_t or tree and
+                     the --gccConfigSystem option is enabled.
+*/
+
+static void doTypeOrPointer (mcPretty_pretty p, decl_node__opaque n);
+
+/*
+   doTypedef - generate a typedef for n provuiding it is not
+*/
+
+static void doTypedef (mcPretty_pretty p, decl_node__opaque n);
+
 /*
    doTypesC -
 */
@@ -3983,6 +4064,25 @@ static bool typePair (decl_node__opaque a, decl_node__opaque b, decl_node__opaqu
 
 static bool needsCast (decl_node__opaque at, decl_node__opaque ft);
 
+/*
+   castDestType - emit the destination type ft
+*/
+
+static void castDestType (mcPretty_pretty p, decl_node__opaque formal, decl_node__opaque ft);
+
+/*
+   identifyPointer -
+*/
+
+static decl_node__opaque identifyPointer (decl_node__opaque type);
+
+/*
+   castPointer - provides a six way cast between ADDRESS (ie void * ),
+                 char * and const char *.
+*/
+
+static unsigned int castPointer (mcPretty_pretty p, decl_node__opaque actual, decl_node__opaque formal, decl_node__opaque at, decl_node__opaque ft);
+
 /*
    checkSystemCast - checks to see if we are passing to/from
                      a system generic type (WORD, BYTE, ADDRESS)
@@ -5538,6 +5638,12 @@ static void makeBaseSymbols (void);
 
 static void makeBuiltins (void);
 
+/*
+   makeCDataTypes - assign the charStarN and constCharStarN to NIL.
+*/
+
+static void makeCDataTypes (void);
+
 /*
    init -
 */
@@ -5556,7 +5662,7 @@ static decl_node__opaque newNode (decl_nodeT k)
   Storage_ALLOCATE ((void **) &d, sizeof (decl_nodeRec));
   if (enableMemsetOnAllocation)
     {
-      d = static_cast<decl_node__opaque> (libc_memset (reinterpret_cast<void *> (d), 0, static_cast<size_t> (sizeof ((*d)))));
+      d = static_cast<decl_node__opaque> (libc_memset (reinterpret_cast <void *> (d), 0, static_cast<size_t> (sizeof ((*d)))));
     }
   if (d == NULL)
     {
@@ -5724,6 +5830,52 @@ static void importEnumFields (decl_node__opaque m, decl_node__opaque n)
 }
 
 
+/*
+   checkGccType - check to see if node n is gcc tree or location_t
+                  and record its use in keyc.
+*/
+
+static void checkGccType (decl_node__opaque n)
+{
+  if (((mcOptions_getGccConfigSystem ()) && ((decl_getScope (static_cast<decl_node> (n))) != NULL)) && ((decl_getSymName (decl_getScope (static_cast<decl_node> (n)))) == (nameKey_makeKey ((const char *) "gcctypes", 8))))
+    {
+      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
+      if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "location_t", 10)))
+        {
+          keyc_useGccLocation ();
+        }
+      else if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "tree", 4)))
+        {
+          /* avoid dangling else.  */
+          keyc_useGccTree ();
+        }
+    }
+}
+
+
+/*
+   checkCDataTypes - check to see if node n is CharStar or ConstCharStar
+                  and if necessary assign n to the global variable.
+*/
+
+static void checkCDataTypes (decl_node__opaque n)
+{
+  if (((decl_getScope (static_cast<decl_node> (n))) != NULL) && ((decl_getSymName (decl_getScope (static_cast<decl_node> (n)))) == (nameKey_makeKey ((const char *) "CDataTypes", 10))))
+    {
+      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
+      if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "CharStar", 8)))
+        {
+          charStarN = n;
+        }
+      else if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "ConstCharStar", 13)))
+        {
+          /* avoid dangling else.  */
+          constCharStarN = n;
+        }
+    }
+}
+
+
 /*
    isComplex - returns TRUE if, n, is the complex type.
 */
@@ -5802,6 +5954,7 @@ static decl_node__opaque makeDef (nameKey_Name n)
   d->defF.source = nameKey_NulName;
   d->defF.hasHidden = false;
   d->defF.forC = false;
+  d->defF.unqualified = false;
   d->defF.exported = Indexing_InitIndex (1);
   d->defF.importedModules = Indexing_InitIndex (1);
   d->defF.constFixup = initFixupInfo ();
@@ -5913,7 +6066,7 @@ static decl_node__opaque addTo (decl_scopeT *decls, decl_node__opaque d)
       /* avoid gcc warning by using compound statement even if not strictly necessary.  */
       if ((symbolKey_getSymKey ((*decls).symbols, n)) == NULL)
         {
-          symbolKey_putSymKey ((*decls).symbols, n, reinterpret_cast<void *> (d));
+          symbolKey_putSymKey ((*decls).symbols, n, reinterpret_cast <void *> (d));
         }
       else
         {
@@ -5923,22 +6076,22 @@ static decl_node__opaque addTo (decl_scopeT *decls, decl_node__opaque d)
     }
   if (decl_isConst (static_cast<decl_node> (d)))
     {
-      Indexing_IncludeIndiceIntoIndex ((*decls).constants, reinterpret_cast<void *> (d));
+      Indexing_IncludeIndiceIntoIndex ((*decls).constants, reinterpret_cast <void *> (d));
     }
   else if (decl_isVar (static_cast<decl_node> (d)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex ((*decls).variables, reinterpret_cast<void *> (d));
+      Indexing_IncludeIndiceIntoIndex ((*decls).variables, reinterpret_cast <void *> (d));
     }
   else if (decl_isType (static_cast<decl_node> (d)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex ((*decls).types, reinterpret_cast<void *> (d));
+      Indexing_IncludeIndiceIntoIndex ((*decls).types, reinterpret_cast <void *> (d));
     }
   else if (decl_isProcedure (static_cast<decl_node> (d)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex ((*decls).procedures, reinterpret_cast<void *> (d));
+      Indexing_IncludeIndiceIntoIndex ((*decls).procedures, reinterpret_cast <void *> (d));
       if (debugDecl)
         {
           libc_printf ((const char *) "%d procedures on the dynamic array\\n", 36, Indexing_HighIndice ((*decls).procedures));
@@ -5957,7 +6110,7 @@ static decl_node__opaque addTo (decl_scopeT *decls, decl_node__opaque d)
 static void export_ (decl_node__opaque d, decl_node__opaque n)
 {
   mcDebug_assert (decl_isDef (static_cast<decl_node> (d)));
-  Indexing_IncludeIndiceIntoIndex (d->defF.exported, reinterpret_cast<void *> (n));
+  Indexing_IncludeIndiceIntoIndex (d->defF.exported, reinterpret_cast <void *> (n));
 }
 
 
@@ -6207,7 +6360,7 @@ static decl_node__opaque addProcedureToScope (decl_node__opaque d, nameKey_Name
   if (((decl_isDef (static_cast<decl_node> (m))) && ((decl_getSymName (static_cast<decl_node> (m))) == (nameKey_makeKey ((const char *) "M2RTS", 5)))) && ((decl_getSymName (static_cast<decl_node> (d))) == (nameKey_makeKey ((const char *) "HALT", 4))))
     {
       haltN = d;
-      symbolKey_putSymKey (baseSymbols, n, reinterpret_cast<void *> (haltN));
+      symbolKey_putSymKey (baseSymbols, n, reinterpret_cast <void *> (haltN));
     }
   return addToScope (d);
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -6375,7 +6528,7 @@ static void putFieldVarient (decl_node__opaque f, decl_node__opaque v)
   switch (v->kind)
     {
       case decl_varient:
-        Indexing_IncludeIndiceIntoIndex (v->varientF.listOfSons, reinterpret_cast<void *> (f));
+        Indexing_IncludeIndiceIntoIndex (v->varientF.listOfSons, reinterpret_cast <void *> (f));
         break;
 
 
@@ -6413,14 +6566,14 @@ static decl_node__opaque putFieldRecord (decl_node__opaque r, nameKey_Name tag,
   switch (r->kind)
     {
       case decl_record:
-        Indexing_IncludeIndiceIntoIndex (r->recordF.listOfSons, reinterpret_cast<void *> (n));
+        Indexing_IncludeIndiceIntoIndex (r->recordF.listOfSons, reinterpret_cast <void *> (n));
         /* ensure that field, n, is in the parents Local Symbols.  */
         if (tag != nameKey_NulName)
           {
             /* avoid gcc warning by using compound statement even if not strictly necessary.  */
             if ((symbolKey_getSymKey (r->recordF.localSymbols, tag)) == symbolKey_NulKey)
               {
-                symbolKey_putSymKey (r->recordF.localSymbols, tag, reinterpret_cast<void *> (n));
+                symbolKey_putSymKey (r->recordF.localSymbols, tag, reinterpret_cast <void *> (n));
               }
             else
               {
@@ -6431,12 +6584,12 @@ static decl_node__opaque putFieldRecord (decl_node__opaque r, nameKey_Name tag,
         break;
 
       case decl_varientfield:
-        Indexing_IncludeIndiceIntoIndex (r->varientfieldF.listOfSons, reinterpret_cast<void *> (n));
+        Indexing_IncludeIndiceIntoIndex (r->varientfieldF.listOfSons, reinterpret_cast <void *> (n));
         p = getParent (r);
         mcDebug_assert (p->kind == decl_record);
         if (tag != nameKey_NulName)
           {
-            symbolKey_putSymKey (p->recordF.localSymbols, tag, reinterpret_cast<void *> (n));
+            symbolKey_putSymKey (p->recordF.localSymbols, tag, reinterpret_cast <void *> (n));
           }
         break;
 
@@ -6472,14 +6625,14 @@ static decl_node__opaque putFieldRecord (decl_node__opaque r, nameKey_Name tag,
 
 static void ensureOrder (Indexing_Index i, decl_node__opaque a, decl_node__opaque b)
 {
-  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast<void *> (a)));
-  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast<void *> (b)));
-  Indexing_RemoveIndiceFromIndex (i, reinterpret_cast<void *> (a));
-  Indexing_RemoveIndiceFromIndex (i, reinterpret_cast<void *> (b));
-  Indexing_IncludeIndiceIntoIndex (i, reinterpret_cast<void *> (a));
-  Indexing_IncludeIndiceIntoIndex (i, reinterpret_cast<void *> (b));
-  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast<void *> (a)));
-  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast<void *> (b)));
+  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast <void *> (a)));
+  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast <void *> (b)));
+  Indexing_RemoveIndiceFromIndex (i, reinterpret_cast <void *> (a));
+  Indexing_RemoveIndiceFromIndex (i, reinterpret_cast <void *> (b));
+  Indexing_IncludeIndiceIntoIndex (i, reinterpret_cast <void *> (a));
+  Indexing_IncludeIndiceIntoIndex (i, reinterpret_cast <void *> (b));
+  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast <void *> (a)));
+  mcDebug_assert (Indexing_IsIndiceInIndex (i, reinterpret_cast <void *> (b)));
 }
 
 
@@ -6584,17 +6737,17 @@ static void addEnumToModule (decl_node__opaque m, decl_node__opaque e)
   mcDebug_assert (((decl_isModule (static_cast<decl_node> (m))) || (decl_isDef (static_cast<decl_node> (m)))) || (decl_isImp (static_cast<decl_node> (m))));
   if (decl_isModule (static_cast<decl_node> (m)))
     {
-      Indexing_IncludeIndiceIntoIndex (m->moduleF.enumFixup.info, reinterpret_cast<void *> (e));
+      Indexing_IncludeIndiceIntoIndex (m->moduleF.enumFixup.info, reinterpret_cast <void *> (e));
     }
   else if (decl_isDef (static_cast<decl_node> (m)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex (m->defF.enumFixup.info, reinterpret_cast<void *> (e));
+      Indexing_IncludeIndiceIntoIndex (m->defF.enumFixup.info, reinterpret_cast <void *> (e));
     }
   else if (decl_isImp (static_cast<decl_node> (m)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex (m->impF.enumFixup.info, reinterpret_cast<void *> (e));
+      Indexing_IncludeIndiceIntoIndex (m->impF.enumFixup.info, reinterpret_cast <void *> (e));
     }
 }
 
@@ -6648,8 +6801,8 @@ static decl_node__opaque doMakeEnumField (decl_node__opaque e, nameKey_Name n)
   if (f == NULL)
     {
       f = newNode (decl_enumerationfield);
-      symbolKey_putSymKey (e->enumerationF.localSymbols, n, reinterpret_cast<void *> (f));
-      Indexing_IncludeIndiceIntoIndex (e->enumerationF.listOfSons, reinterpret_cast<void *> (f));
+      symbolKey_putSymKey (e->enumerationF.localSymbols, n, reinterpret_cast <void *> (f));
+      Indexing_IncludeIndiceIntoIndex (e->enumerationF.listOfSons, reinterpret_cast <void *> (f));
       f->enumerationfieldF.name = n;
       f->enumerationfieldF.type = e;
       f->enumerationfieldF.scope = static_cast<decl_node__opaque> (decl_getDeclScope ());
@@ -6750,17 +6903,17 @@ static void addConstToModule (decl_node__opaque m, decl_node__opaque e)
   mcDebug_assert (((decl_isModule (static_cast<decl_node> (m))) || (decl_isDef (static_cast<decl_node> (m)))) || (decl_isImp (static_cast<decl_node> (m))));
   if (decl_isModule (static_cast<decl_node> (m)))
     {
-      Indexing_IncludeIndiceIntoIndex (m->moduleF.constFixup.info, reinterpret_cast<void *> (e));
+      Indexing_IncludeIndiceIntoIndex (m->moduleF.constFixup.info, reinterpret_cast <void *> (e));
     }
   else if (decl_isDef (static_cast<decl_node> (m)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex (m->defF.constFixup.info, reinterpret_cast<void *> (e));
+      Indexing_IncludeIndiceIntoIndex (m->defF.constFixup.info, reinterpret_cast <void *> (e));
     }
   else if (decl_isImp (static_cast<decl_node> (m)))
     {
       /* avoid dangling else.  */
-      Indexing_IncludeIndiceIntoIndex (m->impF.constFixup.info, reinterpret_cast<void *> (e));
+      Indexing_IncludeIndiceIntoIndex (m->impF.constFixup.info, reinterpret_cast <void *> (e));
     }
 }
 
@@ -8378,7 +8531,7 @@ static DynamicStrings_String getFQstring (decl_node__opaque n)
   DynamicStrings_String i;
   DynamicStrings_String s;
 
-  if ((decl_getScope (static_cast<decl_node> (n))) == NULL)
+  if (((decl_getScope (static_cast<decl_node> (n))) == NULL) || (decl_isDefUnqualified (decl_getScope (static_cast<decl_node> (n)))))
     {
       return DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (decl_getSymName (static_cast<decl_node> (n))));
     }
@@ -8389,7 +8542,7 @@ static DynamicStrings_String getFQstring (decl_node__opaque n)
       s = DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (decl_getSymName (decl_getScope (static_cast<decl_node> (n)))));
       return FormatStrings_Sprintf2 (DynamicStrings_InitString ((const char *) "%s_%s", 5), (const unsigned char *) &s, (sizeof (s)-1), (const unsigned char *) &i, (sizeof (i)-1));
     }
-  else if ((! (decl_isExported (static_cast<decl_node> (n)))) || (mcOptions_getIgnoreFQ ()))
+  else if (((! (decl_isExported (static_cast<decl_node> (n)))) || (mcOptions_getIgnoreFQ ())) || (decl_isDefUnqualified (decl_getScope (static_cast<decl_node> (n)))))
     {
       /* avoid dangling else.  */
       return DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (decl_getSymName (static_cast<decl_node> (n))));
@@ -8415,7 +8568,7 @@ static DynamicStrings_String getFQDstring (decl_node__opaque n, bool scopes)
   DynamicStrings_String i;
   DynamicStrings_String s;
 
-  if ((decl_getScope (static_cast<decl_node> (n))) == NULL)
+  if (((decl_getScope (static_cast<decl_node> (n))) == NULL) || (decl_isDefUnqualified (decl_getScope (static_cast<decl_node> (n)))))
     {
       return DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (getDName (n, scopes)));
     }
@@ -8427,7 +8580,7 @@ static DynamicStrings_String getFQDstring (decl_node__opaque n, bool scopes)
       s = DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (decl_getSymName (decl_getScope (static_cast<decl_node> (n)))));
       return FormatStrings_Sprintf2 (DynamicStrings_InitString ((const char *) "%s_%s", 5), (const unsigned char *) &s, (sizeof (s)-1), (const unsigned char *) &i, (sizeof (i)-1));
     }
-  else if ((! (decl_isExported (static_cast<decl_node> (n)))) || (mcOptions_getIgnoreFQ ()))
+  else if (((! (decl_isExported (static_cast<decl_node> (n)))) || (mcOptions_getIgnoreFQ ())) || (decl_isDefUnqualified (decl_getScope (static_cast<decl_node> (n)))))
     {
       /* avoid dangling else.  */
       return DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (getDName (n, scopes)));
@@ -8490,14 +8643,14 @@ static void doNothing (decl_node__opaque n)
 
 static void doConstC (decl_node__opaque n)
 {
-  if (! (alists_isItemInList (globalGroup->doneQ, reinterpret_cast<void *> (n))))
+  if (! (alists_isItemInList (globalGroup->doneQ, reinterpret_cast <void *> (n))))
     {
       mcPretty_print (doP, (const char *) "#   define ", 11);
       doFQNameC (doP, n);
       mcPretty_setNeedSpace (doP);
       doExprC (doP, n->constF.value);
       mcPretty_print (doP, (const char *) "\\n", 2);
-      alists_includeItemIntoList (globalGroup->doneQ, reinterpret_cast<void *> (n));
+      alists_includeItemIntoList (globalGroup->doneQ, reinterpret_cast <void *> (n));
     }
 }
 
@@ -11978,6 +12131,195 @@ static void doTypeNameModifier (mcPretty_pretty p, decl_node__opaque n)
 }
 
 
+/*
+   isGccType - return TRUE if n is tree or location_t.
+*/
+
+static bool isGccType (decl_node__opaque n)
+{
+  return (mcOptions_getGccConfigSystem ()) && (((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "location_t", 10))) || ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "tree", 4))));
+  /* static analysis guarentees a RETURN statement will be used before here.  */
+  __builtin_unreachable ();
+}
+
+
+/*
+   doGccType - record whether we are going to declare tree or location_t
+               so that the appropriate gcc header can be included instead.
+*/
+
+static void doGccType (mcPretty_pretty p, decl_node__opaque n)
+{
+  if (mcOptions_getGccConfigSystem ())
+    {
+      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
+      if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "location_t", 10)))
+        {
+          outText (p, (const char *) "/* Not going to declare ", 24);
+          doTypeNameC (p, n);
+          outText (p, (const char *) " as it is declared in the gcc header input.h.  */\\n\\n", 53);
+          keyc_useGccLocation ();
+        }
+      else if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "tree", 4)))
+        {
+          /* avoid dangling else.  */
+          outText (p, (const char *) "/* Not going to declare ", 24);
+          doTypeNameC (p, n);
+          outText (p, (const char *) " as it is declared in the gcc header tree.h.  */\\n\\n", 52);
+          keyc_useGccTree ();
+        }
+    }
+}
+
+
+/*
+   isCDataType - return true if n is charStar or constCharStar.
+*/
+
+static bool isCDataType (decl_node__opaque n)
+{
+  return (n != NULL) && ((n == charStarN) || (n == constCharStarN));
+  /* static analysis guarentees a RETURN statement will be used before here.  */
+  __builtin_unreachable ();
+}
+
+
+/*
+   isCDataTypes - return TRUE if n is CharStar or ConstCharStar.
+*/
+
+static bool isCDataTypes (decl_node__opaque n)
+{
+  decl_node__opaque scope;
+
+  scope = static_cast<decl_node__opaque> (decl_getScope (static_cast<decl_node> (n)));
+  return ((scope != NULL) && ((decl_getSymName (static_cast<decl_node> (scope))) == (nameKey_makeKey ((const char *) "CDataTypes", 10)))) && (((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "CharStar", 8))) || ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "ConstCharStar", 13))));
+  /* static analysis guarentees a RETURN statement will be used before here.  */
+  __builtin_unreachable ();
+}
+
+
+/*
+   doCDataTypes - if we are going to declare CharStar or ConstCharStar
+               then generate a comment instead.
+*/
+
+static void doCDataTypes (mcPretty_pretty p, decl_node__opaque n)
+{
+  if (isCDataTypes (n))
+    {
+      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
+      if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "CharStar", 8)))
+        {
+          outText (p, (const char *) "/* Not going to declare ", 24);
+          doTypeNameC (p, n);
+          outText (p, (const char *) " as it is a C type.  */\\n\\n", 27);
+          charStarN = n;
+        }
+      else if ((decl_getSymName (static_cast<decl_node> (n))) == (nameKey_makeKey ((const char *) "ConstCharStar", 13)))
+        {
+          /* avoid dangling else.  */
+          outText (p, (const char *) "/* Not going to declare ", 24);
+          doTypeNameC (p, n);
+          outText (p, (const char *) " as it is a C type.  */\\n\\n", 27);
+          constCharStarN = n;
+        }
+    }
+}
+
+
+/*
+   doCDataTypesC - generate the C representation of the CDataTypes data types.
+*/
+
+static void doCDataTypesC (mcPretty_pretty p, decl_node__opaque n)
+{
+  if (n == charStarN)
+    {
+      outText (p, (const char *) "char *", 6);
+      mcPretty_setNeedSpace (p);
+    }
+  else if (n == constCharStarN)
+    {
+      /* avoid dangling else.  */
+      outText (p, (const char *) "const char *", 12);
+      mcPretty_setNeedSpace (p);
+    }
+}
+
+
+/*
+   doTypeOrPointer - only declare type or pointer n providing that
+                     the name is not location_t or tree and
+                     the --gccConfigSystem option is enabled.
+*/
+
+static void doTypeOrPointer (mcPretty_pretty p, decl_node__opaque n)
+{
+  decl_node__opaque m;
+
+  if (isGccType (n))
+    {
+      doGccType (p, n);
+    }
+  else if (isCDataTypes (n))
+    {
+      /* avoid dangling else.  */
+      doCDataTypes (p, n);
+    }
+  else
+    {
+      /* avoid dangling else.  */
+      m = static_cast<decl_node__opaque> (decl_getType (static_cast<decl_node> (n)));
+      outText (p, (const char *) "typedef", 7);
+      mcPretty_setNeedSpace (p);
+      doTypeC (p, m, &m);
+      if (decl_isType (static_cast<decl_node> (m)))
+        {
+          mcPretty_setNeedSpace (p);
+        }
+      doTypeNameC (p, n);
+      doTypeNameModifier (p, n);
+      outText (p, (const char *) ";\\n\\n", 5);
+    }
+}
+
+
+/*
+   doTypedef - generate a typedef for n provuiding it is not
+*/
+
+static void doTypedef (mcPretty_pretty p, decl_node__opaque n)
+{
+  decl_node__opaque m;
+
+  if (isGccType (n))
+    {
+      doGccType (p, n);
+    }
+  else if (isCDataTypes (n))
+    {
+      /* avoid dangling else.  */
+      doCDataTypes (p, n);
+    }
+  else
+    {
+      /* avoid dangling else.  */
+      m = static_cast<decl_node__opaque> (decl_getType (static_cast<decl_node> (n)));
+      outText (p, (const char *) "typedef", 7);
+      mcPretty_setNeedSpace (p);
+      doTypeC (p, m, &m);
+      if (decl_isType (static_cast<decl_node> (m)))
+        {
+          mcPretty_setNeedSpace (p);
+        }
+      doTypeNameC (p, n);
+      doTypeNameModifier (p, n);
+      outText (p, (const char *) ";\\n\\n", 5);
+    }
+}
+
+
 /*
    doTypesC -
 */
@@ -11996,16 +12338,7 @@ static void doTypesC (decl_node__opaque n)
       else if ((decl_isType (static_cast<decl_node> (m))) || (decl_isPointer (static_cast<decl_node> (m))))
         {
           /* avoid dangling else.  */
-          outText (doP, (const char *) "typedef", 7);
-          mcPretty_setNeedSpace (doP);
-          doTypeC (doP, m, &m);
-          if (decl_isType (static_cast<decl_node> (m)))
-            {
-              mcPretty_setNeedSpace (doP);
-            }
-          doTypeNameC (doP, n);
-          doTypeNameModifier (doP, n);
-          outText (doP, (const char *) ";\\n\\n", 5);
+          doTypeOrPointer (doP, n);
         }
       else if (decl_isEnumeration (static_cast<decl_node> (m)))
         {
@@ -12023,16 +12356,7 @@ static void doTypesC (decl_node__opaque n)
       else
         {
           /* avoid dangling else.  */
-          outText (doP, (const char *) "typedef", 7);
-          mcPretty_setNeedSpace (doP);
-          doTypeC (doP, m, &m);
-          if (decl_isType (static_cast<decl_node> (m)))
-            {
-              mcPretty_setNeedSpace (doP);
-            }
-          doTypeNameC (doP, n);
-          doTypeNameModifier (doP, n);
-          outText (doP, (const char *) ";\\n\\n", 5);
+          doTypedef (doP, n);
         }
     }
 }
@@ -13045,6 +13369,11 @@ static void doTypeC (mcPretty_pretty p, decl_node__opaque n, decl_node__opaque *
     {
       outText (p, (const char *) "void", 4);
     }
+  else if (isCDataTypes (n))
+    {
+      /* avoid dangling else.  */
+      doCDataTypesC (p, n);
+    }
   else if (isBase (n))
     {
       /* avoid dangling else.  */
@@ -13095,15 +13424,17 @@ static void doTypeC (mcPretty_pretty p, decl_node__opaque n, decl_node__opaque *
       /* avoid dangling else.  */
       doSetC (p, n);
     }
+  else if (isCDataTypes (n))
+    {
+      /* avoid dangling else.  */
+      doCDataTypesC (p, n);
+    }
   else
     {
       /* avoid dangling else.  */
-      /* --fixme--  */
-      mcPretty_print (p, (const char *) "to do ...  typedef etc etc ", 27);
-      doFQNameC (p, n);
-      mcPretty_print (p, (const char *) ";\\n", 3);
-      M2RTS_HALT (-1);
-      __builtin_unreachable ();
+      mcMetaError_metaError1 ((const char *) "expecting a type symbol rather than a {%1DMd} {%1DMa}", 53, (const unsigned char *) &n, (sizeof (n)-1));
+      mcError_flushErrors ();
+      mcError_errorAbort0 ((const char *) "terminating compilation", 23);
     }
 }
 
@@ -13160,6 +13491,18 @@ static void doTypeNameC (mcPretty_pretty p, decl_node__opaque n)
       outText (p, (const char *) "void", 4);
       mcPretty_setNeedSpace (p);
     }
+  else if (n == charStarN)
+    {
+      /* avoid dangling else.  */
+      outText (p, (const char *) "char *", 6);
+      mcPretty_setNeedSpace (p);
+    }
+  else if (n == constCharStarN)
+    {
+      /* avoid dangling else.  */
+      outText (p, (const char *) "const char *", 12);
+      mcPretty_setNeedSpace (p);
+    }
   else if (isBase (n))
     {
       /* avoid dangling else.  */
@@ -13582,12 +13925,12 @@ static void doPrototypeC (decl_node__opaque n)
 
 static void addTodo (decl_node__opaque n)
 {
-  if (((n != NULL) && (! (alists_isItemInList (globalGroup->partialQ, reinterpret_cast<void *> (n))))) && (! (alists_isItemInList (globalGroup->doneQ, reinterpret_cast<void *> (n)))))
+  if (((n != NULL) && (! (alists_isItemInList (globalGroup->partialQ, reinterpret_cast <void *> (n))))) && (! (alists_isItemInList (globalGroup->doneQ, reinterpret_cast <void *> (n)))))
     {
       mcDebug_assert (! (decl_isVarient (static_cast<decl_node> (n))));
       mcDebug_assert (! (decl_isVarientField (static_cast<decl_node> (n))));
       mcDebug_assert (! (decl_isDef (static_cast<decl_node> (n))));
-      alists_includeItemIntoList (globalGroup->todoQ, reinterpret_cast<void *> (n));
+      alists_includeItemIntoList (globalGroup->todoQ, reinterpret_cast <void *> (n));
     }
 }
 
@@ -13841,9 +14184,9 @@ static void doSimplifyNode (alists_alist l, decl_node__opaque n)
 
 static void simplifyNode (alists_alist l, decl_node__opaque n)
 {
-  if (! (alists_isItemInList (l, reinterpret_cast<void *> (n))))
+  if (! (alists_isItemInList (l, reinterpret_cast <void *> (n))))
     {
-      alists_includeItemIntoList (l, reinterpret_cast<void *> (n));
+      alists_includeItemIntoList (l, reinterpret_cast <void *> (n));
       doSimplifyNode (l, n);
     }
 }
